SSL API
Source: daemon/proto/hostcraft/v1/ssl.proto
SSLService
Section titled “SSLService”SSLService issues, uploads, renews and installs TLS certificates. REST: /api/v1/ssl.
| Method | REST route | Permission | Streaming |
|---|---|---|---|
ListCertificates |
GET /api/v1/ssl/certificates |
SSLCertRead |
unary |
IssueCertificate |
POST /api/v1/ssl/certificates/issue |
SSLCertIssue |
unary |
UploadCertificate |
POST /api/v1/ssl/certificates/upload |
SSLCertUpload |
unary |
GetCertificate |
GET /api/v1/ssl/certificates/{id} |
SSLCertRead |
unary |
DeleteCertificate |
DELETE /api/v1/ssl/certificates/{id} |
SSLCertDelete |
unary |
RenewCertificate |
POST /api/v1/ssl/certificates/{id}/renew |
SSLCertRenew |
unary |
InstallCertificate |
POST /api/v1/ssl/certificates/{id}/install |
SSLCertInstall |
unary |
GetRenewalSchedule |
GET /api/v1/ssl/renewals/schedule |
SSLCertRenewalRead |
unary |
ListDNSProviders |
GET /api/v1/ssl/dns-providers |
SSLProvidersRead |
unary |
SetDNSProviderCredentials |
POST /api/v1/ssl/dns-providers/{provider}/credentials |
SSLProviderCredsWrite |
unary |
DeleteDNSProviderCredentials |
DELETE /api/v1/ssl/dns-providers/{provider}/credentials |
SSLProviderCredsDelete |
unary |
ListCertificates
Section titled “ListCertificates”/hostcraft.v1.SSLService/ListCertificates
- Request: ListCertificatesRequest
- Response: ListCertificatesResponse
IssueCertificate
Section titled “IssueCertificate”/hostcraft.v1.SSLService/IssueCertificate
- Request: IssueCertificateRequest
- Response: CertificateWorkflowResponse
UploadCertificate
Section titled “UploadCertificate”/hostcraft.v1.SSLService/UploadCertificate
- Request: UploadCertificateRequest
- Response: CertificateWorkflowResponse
GetCertificate
Section titled “GetCertificate”/hostcraft.v1.SSLService/GetCertificate
- Request: GetCertificateRequest
- Response: Certificate
DeleteCertificate
Section titled “DeleteCertificate”/hostcraft.v1.SSLService/DeleteCertificate
- Request: DeleteCertificateRequest
- Response: WorkflowAccepted
RenewCertificate
Section titled “RenewCertificate”/hostcraft.v1.SSLService/RenewCertificate
- Request: RenewCertificateRequest
- Response: WorkflowAccepted
InstallCertificate
Section titled “InstallCertificate”/hostcraft.v1.SSLService/InstallCertificate
- Request: InstallCertificateRequest
- Response: WorkflowAccepted
GetRenewalSchedule
Section titled “GetRenewalSchedule”/hostcraft.v1.SSLService/GetRenewalSchedule
- Request: GetRenewalScheduleRequest
- Response: GetRenewalScheduleResponse
ListDNSProviders
Section titled “ListDNSProviders”/hostcraft.v1.SSLService/ListDNSProviders
- Request: ListDNSProvidersRequest
- Response: ListDNSProvidersResponse
SetDNSProviderCredentials
Section titled “SetDNSProviderCredentials”/hostcraft.v1.SSLService/SetDNSProviderCredentials
- Request: SetDNSProviderCredentialsRequest
- Response: Empty
DeleteDNSProviderCredentials
Section titled “DeleteDNSProviderCredentials”/hostcraft.v1.SSLService/DeleteDNSProviderCredentials
- Request: DeleteDNSProviderCredentialsRequest
- Response: Empty
Messages
Section titled “Messages”Certificate
Section titled “Certificate”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
account_id |
string |
2 | - |
domain_id |
string |
3 | - |
common_name |
string |
4 | - |
sans |
repeated string |
5 | - |
kind |
string |
6 | letsencrypt | zerossl | uploaded | self_signed | buypass | google |
ca |
string |
7 | - |
status |
string |
8 | pending | issued | failed | revoked | expired |
issuer |
string |
9 | - |
not_before |
google.protobuf.Timestamp |
10 | - |
not_after |
google.protobuf.Timestamp |
11 | - |
key_path |
string |
12 | - |
cert_path |
string |
13 | - |
chain_path |
string |
14 | - |
fingerprint |
string |
15 | - |
auto_renew |
bool |
16 | - |
renewal_window_days |
int64 |
17 | - |
last_renewed_at |
google.protobuf.Timestamp |
18 | - |
created_at |
google.protobuf.Timestamp |
19 | - |
CertificateWorkflowResponse
Section titled “CertificateWorkflowResponse”CertificateWorkflowResponse: workflow_id is empty for uploads, which complete synchronously.
| Field | Type | Number | Description |
|---|---|---|---|
certificate |
Certificate |
1 | - |
workflow_id |
string |
2 | - |
DNSProvider
Section titled “DNSProvider”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
name |
string |
2 | - |
credential_keys |
repeated string |
3 | - |
DeleteCertificateRequest
Section titled “DeleteCertificateRequest”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
revoke |
bool |
2 | - |
DeleteDNSProviderCredentialsRequest
Section titled “DeleteDNSProviderCredentialsRequest”| Field | Type | Number | Description |
|---|---|---|---|
provider |
string |
1 | - |
account_id |
string |
2 | - |
Empty is returned by RPCs whose REST route answers with an empty object or 204 No Content.
No fields.
GetCertificateRequest
Section titled “GetCertificateRequest”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
GetRenewalScheduleRequest
Section titled “GetRenewalScheduleRequest”| Field | Type | Number | Description |
|---|---|---|---|
account_id |
string |
1 | - |
GetRenewalScheduleResponse
Section titled “GetRenewalScheduleResponse”| Field | Type | Number | Description |
|---|---|---|---|
entries |
repeated RenewalEntry |
1 | - |
InstallCertificateRequest
Section titled “InstallCertificateRequest”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
site_id |
string |
2 | - |
IssueCertificateRequest
Section titled “IssueCertificateRequest”| Field | Type | Number | Description |
|---|---|---|---|
account_id |
string |
1 | - |
kind |
string |
2 | - |
domain_id |
string |
3 | - |
fqdns |
repeated string |
4 | - |
challenge_type |
string |
5 | http01 | dns01 |
dns_provider |
string |
6 | - |
auto_renew |
bool |
7 | - |
renewal_window_days |
int64 |
8 | - |
site_id |
string |
9 | install onto this site once issued |
ListCertificatesRequest
Section titled “ListCertificatesRequest”| Field | Type | Number | Description |
|---|---|---|---|
account_id |
string |
1 | - |
domain_id |
string |
2 | - |
kind |
string |
3 | - |
ListCertificatesResponse
Section titled “ListCertificatesResponse”| Field | Type | Number | Description |
|---|---|---|---|
certificates |
repeated Certificate |
1 | - |
ListDNSProvidersRequest
Section titled “ListDNSProvidersRequest”No fields.
ListDNSProvidersResponse
Section titled “ListDNSProvidersResponse”| Field | Type | Number | Description |
|---|---|---|---|
providers |
repeated DNSProvider |
1 | - |
RenewCertificateRequest
Section titled “RenewCertificateRequest”| Field | Type | Number | Description |
|---|---|---|---|
id |
string |
1 | - |
force |
bool |
2 | - |
RenewalEntry
Section titled “RenewalEntry”| Field | Type | Number | Description |
|---|---|---|---|
certificate_id |
string |
1 | - |
common_name |
string |
2 | - |
due_at |
google.protobuf.Timestamp |
3 | - |
not_after |
google.protobuf.Timestamp |
4 | - |
SetDNSProviderCredentialsRequest
Section titled “SetDNSProviderCredentialsRequest”| Field | Type | Number | Description |
|---|---|---|---|
provider |
string |
1 | - |
account_id |
string |
2 | - |
credentials |
map<string, string> |
3 | - |
UploadCertificateRequest
Section titled “UploadCertificateRequest”| Field | Type | Number | Description |
|---|---|---|---|
account_id |
string |
1 | - |
domain_id |
string |
2 | - |
key_pem |
bytes |
3 | - |
cert_pem |
bytes |
4 | - |
chain_pem |
bytes |
5 | - |
site_id |
string |
6 | - |
WorkflowAccepted
Section titled “WorkflowAccepted”WorkflowAccepted is the body of every 202 response that only starts a workflow saga. Follow progress with WorkflowService.StreamWorkflow.
| Field | Type | Number | Description |
|---|---|---|---|
workflow_id |
string |
1 | - |